chrome.action.onClicked.addListener((tab) => {
  chrome.scripting.executeScript({
    target: { tabId: tab.id },
    function: toggleHighlight
  });
});

function toggleHighlight() {
  const isActive = document.body.classList.toggle('highlight-active');
  if (isActive) {
    highlightSemanticElements();
  } else {
    removeHighlight();
  }
}

function highlightSemanticElements() {
  const semanticElements = [
    'header', 'nav', 'section', 'article', 'aside', 'footer',
    'figure', 'figcaption', 'main', 'mark', 'time', 'summary',
    'details', 'address', 'blockquote', 'code', 'cite'
  ];

  semanticElements.forEach(tag => {
    const elements = document.querySelectorAll(tag);
    elements.forEach(element => {
      element.classList.add('highlight-semantic');
      element.setAttribute('title', `<${tag}>`);
    });
  });
}

function removeHighlight() {
  const elements = document.querySelectorAll('.highlight-semantic');
  elements.forEach(element => {
    element.classList.remove('highlight-semantic');
    element.removeAttribute('title');
  });
}
