document.getElementById('toggleHighlight').addEventListener('click', () => {
  chrome.tabs.query({ active: true, currentWindow: true }, (tabs) => {
    chrome.scripting.executeScript({
      target: { tabId: tabs[0].id },
      function: () => {
        const isActive = document.body.classList.toggle('highlight-active');
        if (isActive) {
          const semanticElements = [
            'header', 'nav', 'section', 'article', 'aside', 'footer',
            'figure', 'figcaption', 'main', 'mark', 'time', 'summary',
            'details', 'address', 'blockquote', 'code', 'cite'
          ];

          semanticElements.forEach(tag => {
            const elements = document.querySelectorAll(tag);
            elements.forEach(element => {
              element.classList.add('highlight-semantic');
              element.setAttribute('title', `<${tag}>`);
            });
          });
        } else {
          const elements = document.querySelectorAll('.highlight-semantic');
          elements.forEach(element => {
            element.classList.remove('highlight-semantic');
            element.removeAttribute('title');
          });
        }
      }
    });
  });
});
